###  the overall function for bootstrap
FUNboot<-function(PARgrade,PARpref,vecpref,uboot,data1,data2,datapref,s)
{
  set.seed(s, kind=NULL)
  nobs<-dim(data1)[1]
  u1<-uboot[[1]]
  u2<-uboot[[2]]
  
  u1boot<-sample(u1, size=nobs, replace=TRUE)
  u2boot<-sample(u2, size=nobs, replace=TRUE)
  
  e1<-runif(nobs)
  e2<-rnorm(nobs,0,1)
  #
  #prepare the datas for the grade estimation
  allboot<-BOOTALL(PARgrade,PARpref,vecpref,uboot,e1,e2,u1boot,u2boot, data1,data2,datapref)
  b1<-allboot[[1]]
  b2<-allboot[[2]]
  gammaboot<-allboot[[3]]
  tmean<-allboot[[6]]
  tvar<-allboot[[7]]
  
  out<-c(b1, b2, gammaboot, tmean,tvar)
  out
  return(out)
}