# Density function of the timing change utility 
# since students choose after the revelation of m1, it needs to take the intergral of uitlity 
# with respect to the distribution of u1 shocks.

utcondTM<-function(m, DTm, u1, simulTM,utsob,utsf,dtm){
  # the grades 
  m1 <- m[1]
  m2 <- m[2]
  Enem <- m[3] 
  # choice probabilities
  d10 <- DTm[1]
  d11 <- DTm[2]
  d01 <- DTm[3]
  
  m1s<-m1+u1 
  # new thresholds are obtained then move on to 
  bm10TMs <- TTM[1]  - 120*Enem/63 - m1s
  bm10TMf <- TTM[2]  - 120*Enem/63 - m1s
  bm20TMs <- TTM[3]/.6  - 2*(m1s + 120*Enem/63)/3 - as.vector(m2)
  bm20TMf <- TTM[4]/.6  - 2*(m1s + 120*Enem/63)/3 - as.vector(m2)
  
  #compute the stage 1 success probability 
  rk1s <- findInterval(bm10TMs, sort(u1o))
  rk1f <- findInterval(bm10TMf, sort(u1o))
  pm1s <- (nobs+1-rk1s)/(nobs+1)  
  pm1f <- (nobs+1-rk1f)/(nobs+1)
  
  # Drawing in distribution of u1
  # Drawing in distribution of u1
  im1ss <- cbind(rk1s, simulTM)
  u1ss <- t(apply(im1ss, 1, function(x) u1o[ceiling(x[-1]*(nobs-x[1])) + x[1]]))   # Random draw
  # Drawing in distribution of u1
  im1sf<- cbind(rk1f, simulTM)
  u1sf <- t(apply(im1sf, 1, function(x) u1o[ceiling(x[-1]*(nobs-x[1])) + x[1]]))   # Random draw
  
  # Evaluating the success probability conditional on u1
  im2ss <- findInterval((bm20TMs - cfu1*u1ss), u2o)  # Ranking      
  pm2s <- (nobsm2+1-mean(im2ss))/(nobsm2+1)            # Probability of being above the lower bound
  # Evaluating the success probability conditional on u1
  im2sf <- findInterval((bm20TMf  - cfu1*u1sf), u2o)  # Ranking      
  pm2f <- (nobsm2+1-mean(im2sf))/(nobsm2+1)            # Probability of being above the lower bound
  #compute the conditional utility based on realization of u1
  
  utilposttm<- pm1s*pm2s*(utsob*d10  + utsf*d11*dtm ) + pm1f*pm2f*(d01  + d11*(1-dtm) )
  utilposttm
}
